#ifdef PIXEL

uniform Image palettes; // all palettes in a lookup texture
uniform float numPalettes;
uniform Image mappings; // to allow swapping colours arbitrarily
uniform float palette; // which palette is selected

vec4 effect( vec4 color, Image tex, vec2 texture_coords, vec2 screen_coords ) {
    vec4 c = Texel(tex, texture_coords);

    float mappingIndex = float(3 - int((c.r * 255.0) / 85.0));

    float colourIndex = Texel(mappings, vec2(mappingIndex / 4.0, 0)).r;
    vec4 pc = Texel(palettes, vec2(colourIndex / 4.0, palette / numPalettes));


    return vec4(pc.rgb, c.a);
}

#endif