local drawing = require("drawing")
local input = require("input")
local state = require("state")
local game = require("game")

local compmenu = {}


local buttons = {
    {
        text = "Shop",
        x = 192,
        y = 107,
        handle = function()
            state.pop()
            state.push("shop", true)
        end
    },
    {
        text = "Next Wave",
        x = 192,
        y = 107 + 4 + 16,
        handle = function()
            game.startNextWave()
            state.pop()
        end
    },
    {
        text = "Back",
        x = 192,
        y = 107 + 2 * (4 + 16),
        handle = function()
            state.pop()
        end
    },
}

local function pointerOver(button)
    local mx, my = input.pointerPosition()

    return mx >= button.x and mx <= button.x + 96 and my >= button.y and my <= button.y +16
end

function compmenu.init()

end

function compmenu.update(dt)
    if input.justPressed("pointer") then
        for i = 1, #buttons do
            local button = buttons[i]
            if pointerOver(button) then
                button.handle()
            end

        end
    end
end

function compmenu.draw()
    drawing.col(0, 0, 0, 0.7)
    drawing.rect("fill", 0, 0, WIDTH, HEIGHT)
    drawing.col(1, 1, 1, 1)

    for i = 1, #buttons do
        local button = buttons[i]
        drawing.sprite("uiButton", button.x, button.y)
        drawing.printf(button.text, button.x, button.y + 4, 96, "center")    
    end

    
end


return compmenu