local drawing = require("drawing")

local noiseValues = {}
for i = 0,(20*4*12*4)-1 do
    local x = i % 20
    local y = math.floor(i / 20)
    noiseValues[i+1] = math.floor(love.math.noise(x , y) * 100)
end


local floor = {}


function floor.draw(cx, cy)
    
    local fx = math.floor((cx - WIDTH / 2) / 16) * 16
    local fy = math.floor((cy - HEIGHT / 2) / 16) * 16

    for y = 0, (HEIGHT / 16) + 1 do
        for x = 0, (WIDTH / 16) + 1 do
            local rx = x * 16
            local ry = y * 16
            local nx = (rx / 16) % (20*4)
            local ny = (ry / 16) % (12*4)
            local i = (nx ) + (ny  * 20)
            local floorNoise = noiseValues[i+1] 
            local tid = 1

            if floorNoise >= 10 and floorNoise <= 25 then 
                tid = 2
            elseif floorNoise >= 40 and floorNoise <= 48 then
                tid = 3
            end
            
            drawing.tile("floors", tid, rx, ry)  
        end
    end

    love.graphics.setColor(1,1,1,1)

end

return floor