local drawing = require("drawing")
local abilities = require("abilities") 

local hud = {}

local experience
local health

function hud.init(gameData)
    
end

function hud.update(dt, gameData)
  
end

local function drawBar(x, y, max, value, colour)
    drawing.col(0, 0, 0, 0.8)
    drawing.rect("fill", x, y, max*4 + 2, 9 )
    drawing.col(1, 1, 1, 1)
    
    drawing.rect("line", x, y, max*4 + 2, 9 )
    
    drawing.col(colour or colours.white)
    for i = 0, value - 1 do
        local bx = 1 + x + i * 4
        drawing.rect("fill", bx, y + 1, 3, 6)
    end
    drawing.col(1, 1, 1, 1)
end

local function drawBanner(text)
    drawing.col(0,0,0,1)
    drawing.printf(text, -1, 4, WIDTH, "center")
    drawing.printf(text, 1, 4, WIDTH, "center")
    drawing.printf(text, 0, 3, WIDTH, "center")
    drawing.printf(text, 0, 5, WIDTH, "center")
    drawing.printf(text, -1, 3, WIDTH, "center")
    drawing.printf(text, 1, 5, WIDTH, "center")

    drawing.col(1,1,1,1)
    drawing.printf(text, 0, 4, WIDTH, "center")
end
function hud.draw(gameData)
    drawBar(4, 4, gameData.player.maxHp, gameData.player.hp, colours.red)
    drawBar(4, 18, gameData.reactor.maxHp, gameData.reactor.hp, colours.lightblue)
    drawing.print(string.format("$%d", gameData.currency), 4, 30)

    if gameData.waveStarted and not gameData.waveComplete then
        drawBanner(string.format("Wave %d", gameData.wave))
    else
        if uiFrame then
            drawBanner(string.format("Ready to start Wave %d", gameData.wavesSurvived + 1))
        end
    end


end

return hud