local assets = require("assets")

local currentTrack

local music = {}

local masterVolume = 0.25

local volume = 1
local startVol = 1
local targetVolume = 1
local fadeTime = 4
local fadeTimer = 0

function music.update(dt)
    fadeTimer = fadeTimer + dt
    local t = math.min(1, fadeTimer / fadeTime)
    local newVolume = math.lerp(startVol, targetVolume, t)
    if newVolume ~= volume and currentTrack then
        volume = newVolume
        currentTrack:setVolume(masterVolume * volume)
        if volume == 0 then
            currentTrack:stop()
        end 
    end
    
end

function music.fadeIn(trackName)
    targetVolume = 1
    volume = 0
    startVol = 0
    fadeTimer = 0
    local track = assets.music[trackName]
    if track then
        local source = track.source
        
        currentTrack = source
        currentTrack:setLooping(true)
        currentTrack:setVolume(0)
        currentTrack:play()
    end
end

function music.fadeOut()
    targetVolume = 0
    volume = 1
    startVol = 1
    fadeTimer = 0
end

function music.stop()
    if currentTrack then
        currentTrack:stop()
    end
end

function music.play(trackName)
    local track = assets.music[trackName]
    if track then
        local source = track.source
        
        currentTrack = source
        currentTrack:setLooping(true)
        currentTrack:setVolume(masterVolume )
        currentTrack:play()
    end
end

return music