local input = require("input")
local drawing = require("drawing")
local game = require("game")
local state = require("state")
local collision = require("collision")

local placeentity = {}
local gameState
local prototype
local canPlace = false

function placeentity.init(_prototype)
    prototype = _prototype
end

function  placeentity.update(dt)
    local obj = prototype
    local mx, my = input.pointerPosition()
    local x, y, w, h = mx + obj.cx - obj.cr, my + obj.cy - obj.cr, obj.cr * 2, obj.cr * 2
    local items, count = collision.query(x, y, w, h)
    canPlace = count == 0
    if canPlace and input.justPressed("pointer") then
        game.addPlayerHelper(prototype, input.pointerPosition())    
        state.pop()
        state.push("shop")
    end
end

function placeentity.draw()
    local items, count = collision.query(0, 0, WIDTH, HEIGHT, function(item)
        return item.radius ~= nil
    end)

    for i = 1, count do
        local item = items[i]
        drawing.circle("line", item.x, item.y, item.radius)
    end

    local mx, my = input.pointerPosition()

    drawing.col(0, 0, 0, 0.4)
    drawing.rect("fill", 0, 0, WIDTH, HEIGHT)

    drawing.col(1, 1, 1, 0.7)
    if not canPlace then
        local r, g, b = unpack(colours.red)
        drawing.col(r, g, b, 0.7)
    end
    drawing.sprite(prototype.sprite, mx, my)

    if prototype.radius then
        drawing.circle("line", mx, my, prototype.radius)
    end

    drawing.col(1, 1, 1, 1)
    
end

return placeentity