local assets = require("assets")
local drawing = require("drawing")

local tilemap = {}

local function all() return true end

function tilemap.draw(tiledMap, layerFilter)
    layerFilter = layerFilter or all
    if tiledMap.layers then
        local ts = tiledMap.tileset
        local img = assets.images[ts.atlasName]
    
        for l = 1, #tiledMap.layers do
            local layer = tiledMap.layers[l]
            if layer.type == "tilelayer" and layer.visible and layerFilter(layer) then
                local data = layer.data
                for i = 0, #data-1 do
                
                    local x = i % tiledMap.width
                    local y = math.floor(i / tiledMap.width)
                    local id = data[i+1]
                    if id > 0 then
                        local q = ts.quads[id]
                        love.graphics.draw(img, q, x * ts.tileWidth, y * ts.tileHeight)
                    end
                end
            end
        end
    end
end

return tilemap