local input = require("input")
local drawing = require("drawing")

local mx, my = nil, nil

function toWorld(sx, sy)
    local wx, wy = screenToWorld(sx, sy)
    return math.round(wx), math.round(wy)
end

local vstick = {}

function vstick.update()
    if input.justPressed("pointer") then
        mx, my = input.pointerPosition()
    elseif input.justReleased("pointer") then
        vstick.reset()
    end
end

function vstick.reset()
    mx, my = nil, nil
end

function vstick.isActive()
    return mx and my
end

function vstick.getDirection() 
    local cmx, cmy = input.pointerPosition()
    local dx = cmx - mx
    local dy = cmy - my
    return math.norm(dx, dy)
end

function vstick.draw()
    if vstick.isActive() then
        local dx, dy = vstick.getDirection()

        local s = 1

        drawing.col(colours.darkgrey)
        drawing.circle("fill", mx, my, 9 * s)

        drawing.col(colours.black)
        drawing.circle("line", mx, my, 11 * s)
        
        drawing.circle("line", mx, my, 9 * s)
        
        drawing.col(colours.mywhite)
        drawing.circle("line", mx, my, 10 * s)

        drawing.col(colours.black)
        drawing.circle("fill", mx + dx * 4 * s, my + dy * 4 * s, 9 * s)
        drawing.col(colours.mywhite)
        drawing.circle("fill", mx + dx * 4 * s, my + dy * 4 * s, 8 * s)
       
        drawing.col(colours.lightgrey)
        drawing.circle("line", mx + dx * 4 * s, my + dy * 4 * s, 6 * s)
        drawing.col(colours.white)

    end
end

return vstick